
<script>
import Layout from "../../layouts/main";
import PageHeader from "../../components/page-header";
import config from '../../config';
import pagination from "laravel-vue-pagination";
import { promoCodeService } from "../../services";
import moment from "moment";
import { debounce } from "../../Helper/helper"

export default {
  components: {
    Layout,
    PageHeader,
    pagination,
    promoCodeService
  },
  data() {
    const {orderBy,sortBy,status} = this.$route.query;
    return {
        config: config,
        sortBy: sortBy || "id",
        sortDesc: orderBy && orderBy != '' ? true : orderBy,
        search: "",
        status: status == undefined ? "1" :status,
        moment: moment,
        paginations: {},
        limit: 2,
        coupons: [],
        loading: true,
        paginations: {},
        couponCount: '',
        searchData:debounce(()=>{
        if(!this.init){
            const {status,orderBy,sortBy} = this.$data;
            this.$router.replace({name: 'promocode', query: {status,orderBy,sortBy}})
            }
            this.getPromocode();
            this.init = false;
        },500),
        fields: [
            { key: "coupon_image", label: "#", sortable: false },
            { key: "coupon_name", label: "Title", sortable: true },
            { key: "coupon_code", label: "Promo Code", sortable: true },
            { key: "discount_percentage", label: "Discount(%)", sortable: true },
            { key: "flat_discount", label: "Flat Discount", sortable: true },
            { key: "start_datetime", label: "Start Date", sortable: true },
            { key: "end_datetime", label: "End Date", sortable: true },
            { key: "status", label: "Status", sortable: false },
            { key: "action", label: "Action", sortable: false },
        ],
    };
  },
  mounted() {
    this.getPromocode();
  },
  methods: {
    getPromocode(page) {
      this.loading = true;
      var filters = {
          search: this.search,
          status: this.status,
          sortBy: this.sortBy,
          orderBy: this.sortDesc ? "desc" : "asc",
          country: this.country,
          state: this.state,
          city: this.city,
          page: page && page > 0 ? page : 1,
      }
      promoCodeService
        .getPromoCode(filters)
        .then((response) => {
          this.loading = false;
          this.paginations = response.data.result.data;
          this.coupons = response.data.result.data.data;
          this.couponCount = response.data.result.promoCodeCount;
        });
    },
    sortingChanged(ctx) {
        if(ctx.sortBy !== ""){
            this.sortBy = ctx.sortBy;
            this.sortDesc = ctx.sortDesc;
            this.getPromocode();
        }
    },
  }
};
</script>

<template>
  <Layout>
    <div class="row header-new">
        <div class="col-12">
            <div class="d-flex align-items-center justify-content-between icon-main-page coupon-list">
            <div class="page-title-left">
                <div class="avatar-xs mr-3">
                    <span class="avatar-title rounded-circle bg-soft-primary text-primary font-size-18">
                        <i class="bx bx-purchase-tag"></i>
                    </span>
                </div>
                <h4 class="mb-0 font-size-18">{{ trans.get('__JSON__.Promo Codes') }}({{couponCount}})</h4>
            </div>
            <div class="page-title-right align-items-center d-flex">
                <div>
                <router-link :to="{ name: 'promocode-add' }" v-if="$auth.hasPermission(config.permissions.promo_code_write)" class="btn btn-success btn-rounded mr-2 add-btn avatar-xs d-flex align-items-center justify-content-center">
                    <i class="mdi mdi-plus mdi-18px" v-b-tooltip.hover.v-light :title=" trans.get('__JSON__.Add Promo Code')"></i>
                </router-link>
                <router-link :to="{ name: 'promocode-add' }" v-if="$auth.hasPermission(config.permissions.promo_code_write)" class="btn btn-success btn-rounded mr-2 m-add-btn">
                <i class="mdi mdi-plus"></i>
                </router-link>
                </div>
                <div class="d-flex">
                <div class="col-sm-5 brand-status">
                    <div class="form-group">
                    <div class="date-range-list">
                        <select class="custom-select" v-model="status" @change="searchData()">
                        <option value="">{{ trans.get('__JSON__.All') }}</option>
                        <option value="1" selected>{{ trans.get('__JSON__.Active') }}</option>
                        <option value="0">{{ trans.get('__JSON__.Inactive') }}</option>
                        <option value="-1">{{ trans.get('__JSON__.Expired') }}</option>
                        </select>
                    </div>
                    </div>
                </div>
                <div class="search-box d-inline-block">
                    <div class="date-range-list">
                    <div class="position-relative">
                        <input
                        type="text"
                        class="form-control"
                        id="search"
                        @keyup="searchData()"
                        v-model="search"
                        :placeholder="trans.get('__JSON__.Search Placeholder')"
                        />
                        <i class="bx bx-search-alt search-icon"></i>
                    </div>
                    </div>
                </div>
                </div>
            </div>
            </div>
        </div>
    </div>
    <!-- end row -->
    <div class="row list-table-main">
        <div class="col-12">
          <div class="card">
            <div class="card-body">
                <div class="row">
                    <div class="col-12 table-main-list coupon-table">
                        <div class="table-responsive table-border-0 scroll-table">
                            <b-table
                                :items="coupons"
                                :fields="fields" 
                                :sort-by.sync="sortBy"
                                :no-local-sorting="true"
                                @sort-changed="sortingChanged"
                                :busy="loading"
                                show-empty
                            >

                                <template #table-busy>
                                    <div class="text-center text-danger my-2">
                                        <b-spinner class="align-middle"></b-spinner>
                                        <strong>{{trans.get('__JSON__.Loading...')}}</strong>
                                    </div>
                                </template>

                                <template v-slot:cell(coupon_image)="data">
                                    <div v-if="data.item.coupon_image">
                                        <img alt title="product-img" class="vendor-img avatar-xs" :src="config.coupon+data.item.coupon_image"/>
                                    </div>
                                    <div v-else>
                                        <img class="vendor-img avatar-xs" :src="config.no_image" alt />
                                    </div>
                                </template>

                                <template v-slot:cell(coupon_name)="data">
                                    <h5 class="font-size-14">
                                        <div
                                        v-if="data.item.coupon_name > 15"
                                        >{{data.item.coupon_name.substr(0, 15)+ '...'}}</div>
                                        <div v-else>{{data.item.coupon_name}}</div>
                                    </h5>
                                </template>

                                <template v-slot:cell(coupon_code)="data">
                                    <div
                                        v-if="data.item.coupon_code.length > 15"
                                    >{{data.item.coupon_code.substr(0, 15)+ '...'}}</div>
                                    <div v-else>{{data.item.coupon_code}}</div>
                                </template>

                                <template v-slot:cell(start_datetime)="data">
                                    <div
                                        v-if="data.item.start_datetime"
                                    >{{moment(data.item.start_datetime).format('D MMM,Y HH:mm A')}}</div>
                                </template>

                                <template v-slot:cell(end_datetime)="data">
                                    <div
                                        v-if="data.item.end_datetime"
                                    >{{moment(data.item.end_datetime).format('D MMM,Y HH:mm A')}}</div>
                                </template>

                                <template v-slot:cell(status)="data">
                                    <div 
                                    v-if="moment(data.item.end_datetime).isBefore(moment())"
                                    class="badge badge-pill badge-soft-warning font-size-12"
                                    >
                                    {{ trans.get('__JSON__.Expired') }}
                                    </div>
                                    <div
                                        v-else-if="data.item.status === '0'"
                                        class="badge badge-pill badge-soft-danger font-size-12"
                                    >
                                    {{ trans.get('__JSON__.Inactive') }}
                                    </div>
                                    <div
                                        v-else
                                        class="badge badge-pill badge-soft-success font-size-12"
                                    >
                                    {{ trans.get('__JSON__.Active') }}
                                    </div>
                                </template>

                                <template v-slot:cell(action)="data">
                                    <router-link
                                        v-if="$auth.hasPermission(config.permissions.promo_code_write)"
                                        :to="{ name: 'promocode-edit', params: { id: base64(data.item.id) } }"
                                        class="btn btn-success btn-sm btn-rounded"
                                    >{{ trans.get('__JSON__.Edit') }}</router-link>
                                </template>

                                <template #empty>
                                    <p class="text-center">{{ trans.get('__JSON__.No Promo Code') }}</p>
                                </template>
                            </b-table>
                        </div>
                    </div>
                    <div class="row col-sm-5 offset-sm-7">
                        <div class="col">
                            <div class="dataTables_paginate paging_simple_numbers float-right">
                                <ul class="pagination pagination-rounded mb-0">
                                    <pagination
                                        :data="paginations"
                                        :limit="limit"
                                        @pagination-change-page="getPromocode"
                                    ></pagination>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
    </div>
     <!-- end row -->
  </Layout>
</template>